chrome.runtime.onMessage.addListener(function(msg) {
  $("body").css("background-color", msg.color);
});

var logFlag = 1;
var pass, email, token;
var asin;

var root, links;
var content;
var txchange = 0;

var users;
(async() => {
   pass = await getLocalStorage("pass");
   email = await getLocalStorage("email");
   token = await getLocalStorage("token");

   // showConsole(pass);
   // showConsole(email);
   // showConsole(token);

   if(email != null && pass != null){
     tokenCheck(token);
   }
   else{
     addLoginHtml();
   }

   //users = localStorage["name"];
   // users = name.split("<>");
   // userSelect = null;
   // count = 0;
   // users.forEach(function( user ) {
   //      userSelect = userSelect + "<option value=' " + count + " '> " + user + '</option>';
   // });
})();


function addTrackHtml(){
  if(location.href.indexOf("https://www.amazon.co.jp") !== -1){
    addTrackHtmlAmazon();
  }
  if(location.href.indexOf("https://item.rakuten.co.jp/") !== -1 ||
  location.href.indexOf("https://books.rakuten.co.jp/") !== -1){
    //addTrackHtmlRakuten();
  }
  var tmFlag = 0;
  if(document.getElementById("viewTM") != null){
    document.getElementById("viewTM").onclick = function(){
      if(tmFlag == 0){
        tmFlag = 1;
        document.getElementsByClassName("usertm")[0].style.display = "block";
      }
      else{
        tmFlag = 0;
        document.getElementsByClassName("usertm")[0].style.display = "none";
      }

      // document.getElementById("registtrack").onclick = function(){
      //   showConsole("registClick");
      //   sendData();
      // }

    };
  }
}

function addTrackHtmlRakuten(){
  //bodyの直下にこの拡張用のHTMLを生成する処理
  //$("body").prepend("<div id='mybox'></div>");
  setInject("overlay.html");
  sleep(1, function(){
    var itemName = document.getElementsByClassName("item_name")[0];
    if(itemName != null){
      itemName = itemName.innerText;
    }
    else{
      itemName = document.querySelector('[itemprop="name"]');
      if(itemName != null){
        itemName = itemName.firstChild.data;
      }
    }
    var price = document.querySelector('[itemprop="price"]').firstChild.data;
    price = price.replace(/[^0-9]/g, '');

    var soldout = document.getElementsByClassName("soldout_msg")[0];
    if(soldout != null){
      soldout = soldout.innerText;
    }
    else{
      soldout = document.getElementsByClassName("status")[0];
      if(soldout != null){
        soldout = soldout.innerText;
      }
    }

    //iframeにセット
    var setUrl = "https://tracking-m.com/show_overlayrakuten.php?url=" + location.href + "&token=" + token;
    setUrl = setUrl + "&price=" + price + "&soldout=" + encodeURI(soldout) + "&name=" + encodeURI(itemName);

    document.getElementById("tmlogoswitch").style.width = "2.8em";
    document.getElementById("tmlogoswitch").style.height = "2.6em";

    var trackframe = document.getElementById('trackingframe');
    if(trackframe != null){
      console.log(setUrl);
      trackframe.src = setUrl;
    }
    $('#trackingframe').load(function(){
       //console.log('読み込み完了');
       document.getElementById("loadingtrack").style.display="none";
     });
   });
}

function addTrackHtmlAmazon(){
  //bodyの直下にこの拡張用のHTMLを生成する処理
  //$("body").prepend("<div id='mybox'></div>");
  setInject("overlay.html");

  icon = chrome.extension.getURL('icon.png');
  sleep(1, function(){
    //document.getElementById("icon").setAttribute('src', icon);
    showConsole(document.getElementById("icon"));

    //ASINをセット
    var itemName = document.getElementById("productTitle");
    if(itemName != null){
      itemName = itemName.innerText;
    }
    var amaURL = location.href;
    var start = amaURL.indexOf("dp/") + 3;
    var end = start + 10;
    asin = amaURL.substring(start, end);

    if(amaURL.indexOf("product/B") !== -1){
      var start = amaURL.indexOf("product/B") + 8;
      var end = start + 10;
      asin = amaURL.substring(start, end);
    }
    //document.getElementsByClassName("user__title")[0].innerHTML = itemName;
    //document.getElementById("asinview").innerHTML =  asin;

    //iframeにセット
    var setUrl = "https://tracking-m.com/show_overlay.php?asin=" + asin + "&token=" + token + "&name=" + itemName ;
    var trackframe = document.getElementById('trackingframe');
    if(trackframe != null){
      trackframe.contentWindow.location.replace(setUrl);
    }
    $('#trackingframe').load(function(){
	     //console.log('読み込み完了');
       document.getElementById("loadingtrack").style.display="none";
     });

  });

  //Amazonキーワード検索
  if(location.href.indexOf("https://www.amazon.co.jp/s?k") !== -1 ||
  location.href.indexOf("https://www.amazon.co.jp/s?me=") !== -1 ||
  location.href.indexOf("https://www.amazon.co.jp/s?i=merchant-items&me=") !== -1){
    console.log("読み込み待機");
    sleep(0, function(){
      console.log("処理開始");

      /* --Keepaグラフ追加 */
      addListButton("KeepaGraph", "keepagraph");

      var a = function() {
        if (content != $('.a-selected').text()) {
            if (content != null) {
              txchange = txchange + 1;
              if(txchange == 2){
                //alert('Change!');
                addListButton("KeepaGraph", "keepagraph");
                txchange = 0;
              }
            }
            content = $('.a-selected').text();
        }
    };
    setInterval(a, 300);

    });
  }

  //ストアフロントでリサーチ済み
  if(location.href.indexOf("https://www.amazon.co.jp/s?i=merchant-items&me=") !== -1 ||
  location.href.indexOf("https://www.amazon.co.jp/s?me=") !== -1 ){
    var amaURL = location.href;
    var start = amaURL.indexOf("me=") + 3;
    var str = amaURL.substring(start);
    var end = str.indexOf("&");
    var sellerid = str.substring(0, end);
    console.log(sellerid);

    $.ajax({
      type: "POST",
      url: "https://tracking-m.com/get_sellercheck.php",
      data:{
        sellerid : sellerid,
        token: token,
      },
      //dataType: "jsonp",
      success : function(json){
        console.log(json);
        if(json == "リサーチ済み"){
          toastr["info"]("既にリサーチ済みのストアです。");

          var setHead = document.getElementsByClassName("a-section a-spacing-small a-spacing-top-small")[0];
          var div = document.createElement("div");
          div.innerHTML = "既にリサーチ済みのストアです。";
          div.style.cssText = "color:red;font-size:1.2em;";
          setHead.appendChild(div);
        }
        else{
          var setHead = document.getElementsByClassName("a-section a-spacing-small a-spacing-top-small")[0];
          var div = document.createElement("div");
          div.innerHTML = "<button id='sellercheckgo'>リサーチ済みにする</button>";
          div.style.cssText = "color:red;font-size:1.2em;";
          setHead.appendChild(div);

          document.getElementById("sellercheckgo").onclick = function(){
            $.ajax({
              type: "POST",
              url: "https://tracking-m.com/reg_sellercheck.php",
              data:{
                sellerid : sellerid,
                token: token,
              },
              //dataType: "jsonp",
              success : function(json){
                console.log(json);
              }
            });

            console.log("リサーチ済み");
            document.getElementById("sellercheckgo").style.display = "none";

            var setHead = document.getElementsByClassName("a-section a-spacing-small a-spacing-top-small")[0];
            var div = document.createElement("div");
            div.innerHTML = "既にリサーチ済みのストアです。";
            div.style.cssText = "color:red;font-size:1.2em;";
            setHead.appendChild(div);
          };//onclick
        }//if

        //showConsole(json);
        // if(debugFlg == 1){
        //   showConsole("データ保存OKSET");
        //   showConsole(json);
        // }
      }
    });
  }

  //URLの変化(バリエーション変化を検知)
var href = location.href;
var observer = new MutationObserver(function(mutations) {
  if(href !== location.href) {
    console.log("changeURL");
    addTrackHtml();

    href = location.href;
  }
});

observer.observe(document, { childList: true, subtree: true });

  // 各エレメント生成
  function addListButton(buttonText, id){
    //console.log("Alibaba");
    /* --Alibaba */
    getElem();
    setListButton(root, buttonText, id);
  }

  function getElem(){
    root = $('h2[class^="a-size-mini a-spacing-none a-color-base s-line-clamp"]');
    links = document.getElementsByClassName("a-link-normal a-text-normal");
  }

  function setListButton(root, buttonText, id){
    for(var i=0;i<root.length;i++){
      var amaURL = root[i].children[0].href;
      var start = amaURL.indexOf("dp/") + 3;
      var end = start + 10;
      asin = amaURL.substring(start, end);

      if(asin.indexOf("tps:/") !== -1){
        asin ="なし";
      }
      else{
        //console.log(asin);
        var setDiv = "https://at-giga.com/sys/get_keepaimage.php?asin=" + asin + "&width=500&height=200";
        var div = document.createElement("img");
        div.setAttribute("id", "keepaimg" + asin);
        div.setAttribute("src", setDiv);
        //root[i].appendChild(div);
        if(document.getElementById("keepaimg" + asin) == null){
          root[i].parentNode.append(div);
        }

      }

      //console.log(asin);
    }
  }

  showConsole("TrackingManager");
}

function addLoginHtml(){
  //bodyの直下にこの拡張用のHTMLを生成する処理
  //$("body").prepend("<div id='mybox'></div>");

  setInject("login.html");

  sleep(1, function(){
    //document.getElementById("icon").setAttribute('src', icon);

    var tmFlag = 0;
    document.getElementById("viewTM").onclick = function(){
      if(tmFlag == 0){
        tmFlag = 1;
        document.getElementsByClassName("user")[0].style.display = "block";
      }
      else{
        tmFlag = 0;
        document.getElementsByClassName("user")[0].style.display = "none";
      }

    };

    $('#logintrack').on("click",function(){
      showConsole("loginClick");
      sendLogin();
    });

  });

  showConsole("TrackingManager");
}

function setInject(setHtml){
  var div = document.createElement("div");
  div.id="mybox";
  var elm = document.getElementById("productTitle");
  if(elm != null){
    elm.appendChild(div);
  }
  else{
    elm = document.getElementById("floatingCartContainer");
  }
  if(elm != null){
    //div.style.cssText = "margin-top:20em!important;position:fixed!imporant;z-index:999999!important;";
    elm.appendChild(div);
  }

  stylesheet = chrome.extension.getURL('trstyle.css');
  stylesheet2 = chrome.extension.getURL('formstyle.css');
  stylesheet3 = chrome.extension.getURL('toastr.css');
  //stylesheet2 = chrome.extension.getURL('jquery.toast.min.css');
  script = chrome.extension.getURL('jquery.min.js');
  script2 = chrome.extension.getURL('toastr.min.js');
  sethtml1 = '<link rel="stylesheet" href="'+stylesheet+'" type="text/css"><script src=" ' + script + '"></script> ' ; //'<link rel="stylesheet" href="'+stylesheet2+'" type="text/css">';
  sethtml1 = sethtml1 + '<script src=" ' + script2 + '"></script> ' ; //'<link rel="stylesheet" href="'+stylesheet2+'" type="text/css">';
  sethtml1 = sethtml1 + '<link rel="stylesheet" href="' + stylesheet2 + '" type="text/css">';
  sethtml1 = sethtml1 + '<link rel="stylesheet" href="' + stylesheet3 + '" type="text/css">';
  $("head").append(sethtml1);
  icon = chrome.extension.getURL('icon.png');

  sethtml2 = '<a href="javascript:void(0)" id="viewTM"><img id="tmlogoswitch" style="width:2.2em; height:2em;" src=' + icon + '></a> ';
  $("#mybox").html(sethtml2);
  injDiv = document.createElement("div");
  div.appendChild(injDiv);

  injectHtml(setHtml, injDiv);
  icon = chrome.extension.getURL('icon.png');

  //ドキュメントロード時に、toastr のオプションを設定する
  	toastr.options = {
  	  "closeButton": false,
  	  "debug": false,
  	  "newestOnTop": false,
  	  "progressBar": true,
  	  "positionClass": "toast-bottom-right",
  	  "preventDuplicates": true,
  	  "onclick": null,
  	  "showDuration": "100",
  	  "hideDuration": "500",
  	  "timeOut": "2000",
  	  "extendedTimeOut": "1000",
  	  "showEasing": "swing",
  	  "hideEasing": "linear",
  	  "showMethod": "fadeIn",
  	  "hideMethod": "fadeOut"
  }
}

//送信データ
function sendData(){
  var asin = document.getElementById("asinview").innerHTML;
  var name = document.getElementsByClassName("user__title")[0].innerHTML;
  var aPricelow = document.getElementById("setnewlow").value;
  var aPricehigh = document.getElementById("setnewhigh").value;
  var oPricelow = document.getElementById("setusedlow").value;
  var oPricehigh = document.getElementById("setusedhigh").value;
  var rankinglow = document.getElementById("rankinglow").value;
  var rankinghigh = document.getElementById("rankinghigh").value;
  var nStoreCountlow = document.getElementById("nStoreCountlow").value;
  var nStoreCounthigh = document.getElementById("nStoreCounthigh").value;
  var oStoreCountlow = document.getElementById("oStoreCountlow").value;
  var oStoreCounthigh = document.getElementById("oStoreCounthigh").value;
  var amaPricelow = document.getElementById("amaPricelow").value;
  var amaPricehigh = document.getElementById("amaPricehigh").value;

  showConsole(asin);
  showConsole(name);
  showConsole(aPricelow);
  showConsole(aPricehigh);
  showConsole(oPricelow);
  showConsole(oPricehigh);
  showConsole(rankinglow);
  showConsole(rankinghigh);
  showConsole(nStoreCountlow);
  showConsole(nStoreCounthigh);
  showConsole(oStoreCountlow);
  showConsole(oStoreCounthigh);
  showConsole(amaPricelow);
  showConsole(amaPricehigh);

  $.ajax({
    type: "POST",
    url: "https://nijibin.xyz/reg_trackset.php",
    data:{
      asin : asin,
      name: name,
      aPriceLow: aPricelow,
      aPriceHigh: aPricehigh,
      oPriceLow: oPricelow,
      oPriceHigh: oPricehigh,
      rankingLow: rankinglow,
      rankingHigh: rankinghigh,
      nStoreCountLow: nStoreCountlow,
      nStoreCountHigh: nStoreCounthigh,
      oStoreCountLow: oStoreCountlow,
      oStoreCountHigh: oStoreCounthigh,
      amaPriceLow: amaPricelow,
      amaPriceHigh: amaPricehigh,
      token: token,
    },
    //dataType: "jsonp",
    success : function(json){
      toastr["info"]("登録完了しました。");
      //showConsole(json);
      // if(debugFlg == 1){
      //   showConsole("データ保存OKSET");
      //   showConsole(json);
      // }
    }
  });
}

function tokenCheck(token){
  $.ajax({
    type: "POST",
    url: "https://nijibin.xyz/logintrack.php",
    data:{
      token : token,
    },
    //dataType: "jsonp",
    success : function(json){
      //showConsole(json);
      if(json != "削除済みのユーザーです。" && json != "ログインに失敗しました。"){
        showConsole("ログイン完了");
        addTrackHtml();
      }
      else{
        showConsole("ログイン失敗");
        // alert("ログインに失敗しました。");
      }
      // if(debugFlg == 1){
      //   showConsole("データ保存OKSET");
      //   showConsole(json);
      // }
    }
  });
}

//送信データ
function sendLogin(){
  var email = document.getElementById("setemail").value;
  var pass = document.getElementById("setpass").value;
  var appID = chrome.extension.getURL('icon.png');

  appID = appID.replace("/icon.png", "");
  appID = appID.replace("chrome-extension://", "");
  //showConsole(email);
  //showConsole(pass);
  //showConsole(appID);

  $.ajax({
    type: "POST",
    url: "https://nijibin.xyz/logintrack.php",
    data:{
      email : email,
      appID : appID,
      pass: pass,
    },
    //dataType: "jsonp",
    success : function(json){
      //showConsole(json);
      if(json != "削除済みのユーザーです。" && json != "ログインに失敗しました。"){
        showConsole("ログイン完了");
        alert("ログイン完了しました。");

        setLocalStorage("email", email);
        setLocalStorage("pass", pass);
        setLocalStorage("token", json);

        addTrackHtml();

      }
      else{
        showConsole("ログイン失敗");
        alert("ログインに失敗しました。");
      }
      // if(debugFlg == 1){
      //   showConsole("データ保存OKSET");
      //   showConsole(json);
      // }
    }
  });
}

function showConsole(log){
  if(logFlag == 1){
    console.log(log);
  }
}

// setIntervalを使う方法
function sleep(waitSec, callbackFunc) {
  waitSec = waitSec * 10;
  // 経過時間（秒）
  var spanedSec = 0;

  // 1秒間隔で無名関数を実行
  var id = setInterval(function () {

    spanedSec++;

    // 経過時間 >= 待機時間の場合、待機終了。
    if (spanedSec >= waitSec) {

      // タイマー停止
      clearInterval(id);

      // 完了時、コールバック関数を実行
      if (callbackFunc) callbackFunc();
    }
  }, 100);

}

//
function setLocalStorage(name, value) {
    return new Promise( (resolve) => {
        x = name;
        obj = { [x]: value };
        chrome.storage.local.set( obj, () => resolve() );
    });
}

function getLocalStorage(key = null) {
    return new Promise( (resolve) => {
        chrome.storage.local.get(key, (item) => {
            key ? resolve(item[key]) : resolve(item);
        });
    });
}

async function injectHtml(resource, dom) {
    if(resource != null && dom != null){
      const res = await fetch(chrome.runtime.getURL(resource), { method: "GET" })
      const html = await res.text()
      try{
        if(dom != null){
          dom.innerHTML = html;
        }

      }catch(e){
        showConsole(e);
      }
    }


}

/*
// localStorageに保存されているkey名'foo'の値を取得する場合
chrome.runtime.sendMessage({method: 'getItem', key: 'foo'}, function (response) {
  if (response.data) {
    showConsole(response.data);
  }
});

// localStorageにkey名'baa'として値2を保存する場合
chrome.runtime.sendMessage({method: 'setItem', key: 'foo', value: 2});

// localStorageのkey名'foo'の値を削除する場合
chrome.runtime.sendMessage({method: 'removeItem', key: 'foo'});

*/
