$(function(){
  var  background = chrome.extension.getBackgroundPage();
  // セーブボタンが押されたら、
  // ローカルストレージに保存する。
  $("#save").click(function () {
    // Save it using the Chrome extension storage API.
    chrome.storage.sync.set({'name': $("#name").val() , 'email': $("#email").val(), 'tel': $("#tel").val()  }, function() {
      console.log('Settings saved');
    });

    (async() => {
       await setLocalStorage({ 'name': $("#name").val() , 'email': $("#email").val(), 'tel': $("#tel").val() });

       let aaa = await getLocalStorage("name");
       let bbb = await getLocalStorage("email");
       let all = await getLocalStorage();

       console.log(aaa);// 1
       console.log(bbb);// 2
       console.log(all);// {aaa: 1, bbb: 2}
   })();

    localStorage["bgcolor"] = $("#bgcolor").val();
  });

  // オプション画面の初期値を設定する
  // Read it using the storage API
  (async() => {
     let name = await getLocalStorage("name");
     let email = await getLocalStorage("email");
     let tel = await getLocalStorage("tel");


     if (name) {
       $("#name").val(name);
     }

     if (email) {
       $("#email").val(email);
     }

     if (tel) {
       $("#tel").val(tel);
     }

 })();


  if (localStorage["bgcolor"]) {
    var bgcolor = localStorage["bgcolor"];
    $("#bgcolor option[value=" + bgcolor + "]").attr("selected", true);
  }

 function setLocalStorage(obj) {
     return new Promise( (resolve) => {
         chrome.storage.local.set( obj, () => resolve() );
     });
 }

 function getLocalStorage(key = null) {
     return new Promise( (resolve) => {
         chrome.storage.local.get(key, (item) => {
             key ? resolve(item[key]) : resolve(item);
         });
     });
 }
});
